﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Blackhole : MonoBehaviour {
	// 使い方
	// sphere型おオブジェクトに、このスクリプトをアタッチ
	// Colliderコンポーネントの isTriggerにチェックを入れること

	public float pullPower = 100.0f;
	private Rigidbody rb;

	void OnTriggerStay(Collider c) {
		Debug.Log("in BlackHole!");
		if(c.gameObject.tag == "Player") {
			// ブラックホールと自機の距離に応じて、近いほど吸い込む力は働く
			// 吸い込む方向は、自機からブラックホールの中心に向かうベクトル
			// cがプレイヤー
			Vector3 pullVector = transform.position - c.transform.position;

			rb = c.gameObject.GetComponent<Rigidbody>();
			var mps = pullPower * (1000f / 3600f);
			var v = pullVector * mps;	// 進む方向
			var force = (rb.mass * rb.drag * v) / (1f - rb.drag * Time.fixedDeltaTime);
			rb.AddForce(force);
		}
	}

	// ブラックホールパーティクル参考
	// http://ndabecha.blogspot.jp/2016/07/unity-particle-typhoon.html
}
