﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Goal : MonoBehaviour {
	// playerオブジェクトのタグを Player にすること
	// playerオブジェクトにRigidbodyがアタッチされていること
	// GoalRadius は、ゴールとの当たり判定範囲を半径で指定(MeshCollider範囲)

	public float goalRadian = 4.6f;

	private GameObject gameManagerObject;
	private GameManager gameManager;
	void Start() {
		gameManagerObject = GameObject.Find("GameManager");
		gameManager = gameManagerObject.GetComponent<GameManager>();
	}


	void OnCollisionEnter(Collision c) {
		// 触れた時の距離を算出(playerのY_Scaleを引いておく)
		float touchDistance = Vector3.Distance(transform.position, c.transform.position) - transform.localScale.y;
		// 0が理論上の最小値だが、-0.00001とか出るので、絶対値を取り四捨五入もしておく
		touchDistance = Mathf.Round( touchDistance * 10 )/10;
		if (c.gameObject.tag.Equals("Player")) {
			Debug.Log("Ground に着地！ 距離 :  " +touchDistance );
			if( goalRadian >= touchDistance ) {
				gameManager.isGoal = true;
				// Debug.Log("ゴールだよ");
			}
		}
	}

}
