﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class StartTriggerArea : MonoBehaviour {
	// あらかじめ同シーン内に DependSceneLoader をアタッチしたオブジェクトを配置しておき、
	// Inspectorタブすぐ下のチェックをOFFにしておくこと。
	// SceneNameには次に遷移したいシーン名を記述しておくこと
	// Fadeも同様
	public string sceneName;

	public GameObject fade;
	public GameObject haveaNiceTrip;

	// トリガーとの接触時に呼ばれるコールバック
	void OnTriggerEnter (Collider hit) {
		Debug.Log("ゲームスタート(シーン遷移)");
		// 接触対象はPlayerタグですか？
		if (hit.CompareTag ("Player")) {
			// Have a Nice Trip!
			haveaNiceTrip.SetActive(true);
			// フェードアウト
			fade.SetActive(true);
			// 一定時間後にシーン遷移
			Invoke("loadLevel", 3.0f);
		}
	}

	public void loadLevel () {
		SceneManager.LoadScene (sceneName);
	}
}
