﻿using UnityEngine;
using System.Collections;

public class dummyPlayer : MonoBehaviour {
	// 使い方
	// プレイヤーとなるオブジェクトにRigidbodyをアタッチする
	// Dragは0より大きい値にする
	// (RigidbodyのFreeze Rotationをを固定する:ダミー用)
	// 当たり判定を行う地面のtagを、PlaneTouchGroundにする(仮)
	// goalRadianの値で、ゴール着地判定の半径を調整できる

	public float kmph = 100f;
	public float goalRadian = 3.0f;
	private Rigidbody rb;

	void Start() {
		rb = GetComponent<Rigidbody>();
	}

	void Update () {

		//===============================
		// 下記ダミー用playerの移動制御
		var mps = kmph * (1000f / 3600f);

		// スペースで上昇
		if( Input.GetKey(KeyCode.Space) ) {
			var v = transform.up * mps;	// 進む方向
			var force = (rb.mass * rb.drag * v) / (1f - rb.drag * Time.fixedDeltaTime);
			rb.AddForce(force);
		}
		// 矢印キーで前後左右移動
		if( Input.GetKey(KeyCode.UpArrow) ){
			var v = transform.forward * mps;	// 進む方向
			var force = (rb.mass * rb.drag * v) / (1f - rb.drag * Time.fixedDeltaTime);
			rb.AddForce(force);
		}
		if( Input.GetKey(KeyCode.DownArrow) ) {
			var v = -transform.forward * mps;	// 進む方向
			var force = (rb.mass * rb.drag * v) / (1f - rb.drag * Time.fixedDeltaTime);
			rb.AddForce(force);
		}
		if( Input.GetKey(KeyCode.RightArrow) ) {
			var v = transform.right * mps;	// 進む方向
			var force = (rb.mass * rb.drag * v) / (1f - rb.drag * Time.fixedDeltaTime);
			rb.AddForce(force);
		}
		if( Input.GetKey(KeyCode.LeftArrow) ) {
			var v = -transform.right * mps;	// 進む方向
			var force = (rb.mass * rb.drag * v) / (1f - rb.drag * Time.fixedDeltaTime);
			rb.AddForce(force);
		}
		// ダミー用ここまで
		//===============================

	}

	/*
	void OnCollisionEnter(Collision c) {
		// 長方形型のゴールオブジェクトの場合
		//Debug.Log("Plane Collision");
		// 触れた時の距離を算出(playerのY_Scaleを引いておく)
		float touchDistance = Vector3.Distance(transform.position, c.transform.position) - transform.localScale.y;
		// 0が理論上の最小値だが、-0.00001とか出るので、絶対値を取り四捨五入もしておく
		touchDistance = Mathf.Round( touchDistance * 10 )/10;
		if (c.gameObject.tag.Equals("PlaneTouchGround")) {
			Debug.Log("Ground に着地！ 距離 :  " +touchDistance );
			if( goalRadian >= touchDistance ) {
				Debug.Log("ゴールだよ");
			}
		}
	}
	*/

}
