﻿using UnityEngine;
using UnityEngine.SceneManagement;
using System.Collections;
#if UNITY_EDITOR
using UnityEditor;
using UnityEditor.SceneManagement;
#endif
using System.IO;

// 依存しているシーンの定義
// 初期化時にシーンを追加で読み込む
// スクリプトの実行優先度を上げておく必要がある
public class DependSceneLoader : MonoBehaviour
{
    [Tooltip ("シーン名")]
    public string sceneName;

    private void Awake ()
    {
        //print ("load depend scene: " + scenePath);
        string name = Path.GetFileNameWithoutExtension (sceneName);
        if (name != "" && !SceneManager.GetSceneByName (name).isLoaded) {
            SceneManager.LoadScene (name, LoadSceneMode.Additive);
        }
    }
}
