﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerController2 : MonoBehaviour {
    public float jetPowerMax = 5f;
    public GameObject body;
    public GameObject handL;
    public GameObject handR;
    private Rigidbody rb;

    private float forceL;
    private float forceR;
    public Vector3 defaultHandLPos = new Vector3(-0.3f, 0.25f, 0f);
    public Vector3 defaultHandRPos = new Vector3(-0.3f, -0.25f, 0f);
    private Vector3 posL;
    private Vector3 posR;

	// 燃料管理用にGameManagerにアクセスする
	private GameObject gameManagerObject;
	private GameManager gameManager;
	private bool isFuelEmpty = false;

    // Use this for initialization
    void Start()
    {
        rb = body.GetComponent<Rigidbody>();
        forceL = 0;
        forceR = 0;
        posL = defaultHandLPos;
        posR = defaultHandRPos;

		// 燃料管理用にGameManagerにアクセス
		gameManagerObject = GameObject.Find("Manager");
		gameManager = gameManagerObject.GetComponent<GameManager>();
    }

    // Update is called once per frame
    void Update()
    {
        //if(Input.GetKey(KeyCode.A)) posL = new Vector3(-0.1f,-0.1f,0f);
        //if(Input.GetKeyUp(KeyCode.A)) posL = defaultHandLPos;
        //if(Input.GetKey(KeyCode.K)) posR = new Vector3(-0.1f,0.1f,0f);
        //if(Input.GetKeyUp(KeyCode.K)) posR = defaultHandRPos;

        //if(Input.GetKeyDown(KeyCode.Q)) forceL = jetPowerMax;
        //if(Input.GetKeyDown(KeyCode.O)) forceR = jetPowerMax;
        //if(Input.GetKeyUp(KeyCode.Q)) forceL = 0;
        //if(Input.GetKeyUp(KeyCode.O)) forceR = 0;

        SteamVR_TrackedObject leftObject = handL.GetComponent<SteamVR_TrackedObject>();
        var deviceL = SteamVR_Controller.Input((int)leftObject.index);

        SteamVR_TrackedObject rightObject = handR.GetComponent<SteamVR_TrackedObject>();
        var deviceR = SteamVR_Controller.Input((int)rightObject.index);

        var deviceHmd = SteamVR_Controller.Input((int)SteamVR_TrackedObject.EIndex.Hmd);

        float trigerL = deviceL.GetAxis(Valve.VR.EVRButtonId.k_EButton_SteamVR_Trigger).x;
        float trigerR = deviceR.GetAxis(Valve.VR.EVRButtonId.k_EButton_SteamVR_Trigger).x;

        //左手
        if (trigerL > 0.0f)
        {
            forceL = jetPowerMax * trigerL;
        }
        //右手
        if (trigerR > 0.0f)
        {
            forceR = jetPowerMax * trigerR;
        }

        posL = deviceHmd.transform.pos - deviceL.transform.pos;
        posR = deviceHmd.transform.pos - deviceR.transform.pos;

        handL.transform.localPosition = posL;
        handR.transform.localPosition = posR;

		// Fuel減少
		isFuelEmpty = gameManager.useFuel(forceL + forceR);
		if( isFuelEmpty ) {
			// 燃料が空っぽならうごかなくなる
		} else {
			rb.AddForceAtPosition(handL.transform.forward * -1.0f * forceL, handL.transform.position);
			rb.AddForceAtPosition(handR.transform.forward * -1.0f * forceR, handR.transform.position);
		}

        Debug.Log("triger:" + trigerL + ":" + trigerR);
        Debug.Log("Force:" + forceL.ToString() + ":" + forceR.ToString());
        Debug.Log("Position:" + posL.ToString() + ":" + posR.ToString());
    }
}
